Index: netproto/smb/smb_conn.c
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_conn.c,v
retrieving revision 1.6
diff -u -r1.6 smb_conn.c
--- netproto/smb/smb_conn.c	10 Nov 2003 06:12:16 -0000	1.6
+++ netproto/smb/smb_conn.c	22 Feb 2004 07:36:13 -0000
@@ -82,7 +82,7 @@
 {
 
 	smb_co_init(&smb_vclist, SMBL_SM, "smbsm", curthread);
-	smb_co_unlock(&smb_vclist, 0, curthread);
+	smb_co_unlock(&smb_vclist, NULL, 0, curthread);
 	return 0;
 }
 
@@ -102,13 +102,13 @@
 static int
 smb_sm_lockvclist(int flags, struct thread *td)
 {
-	return smb_co_lock(&smb_vclist, flags | LK_CANRECURSE, td);
+	return smb_co_lock(&smb_vclist, NULL, flags | LK_CANRECURSE, td);
 }
 
 static void
 smb_sm_unlockvclist(struct thread *td)
 {
-	smb_co_unlock(&smb_vclist, LK_RELEASE, td);
+	smb_co_unlock(&smb_vclist, NULL, LK_RELEASE, td);
 }
 
 static int
@@ -226,7 +226,7 @@
 	lockinit(&cp->co_lock, 0, objname, 0, 0);
 	cp->co_level = level;
 	cp->co_usecount = 1;
-	KASSERT(smb_co_lock(cp, LK_EXCLUSIVE, td) == 0,
+	KASSERT(smb_co_lock(cp, NULL, LK_EXCLUSIVE, td) == 0,
 	    ("smb_co_init: lock failed"));
 }
 
@@ -246,7 +246,7 @@
 		cp->co_gone(cp, scred);
 	parent = cp->co_parent;
 	if (parent) {
-		smb_co_lock(parent, LK_EXCLUSIVE, scred->scr_td);
+		smb_co_lock(parent, NULL, LK_EXCLUSIVE, scred->scr_td);
 		SLIST_REMOVE(&parent->co_children, cp, smb_connobj, co_next);
 		smb_co_put(parent, scred);
 	}
@@ -257,48 +257,53 @@
 void
 smb_co_ref(struct smb_connobj *cp, struct thread *td)
 {
+	smb_ilock ilock;
 
-	SMB_CO_LOCK(cp);
+	SMB_CO_LOCK(&ilock, cp);
 	cp->co_usecount++;
-	SMB_CO_UNLOCK(cp);
+	SMB_CO_UNLOCK(&ilock);
 }
 
 void
 smb_co_rele(struct smb_connobj *cp, struct smb_cred *scred)
 {
 	struct thread *td = scred->scr_td;
+	smb_ilock ilock;
 
-	SMB_CO_LOCK(cp);
+	SMB_CO_LOCK(&ilock, cp);
 	if (cp->co_usecount > 1) {
 		cp->co_usecount--;
-		SMB_CO_UNLOCK(cp);
+		SMB_CO_UNLOCK(&ilock);
 		return;
 	}
 	if (cp->co_usecount == 0) {
 		SMBERROR("negative use_count for object %d", cp->co_level);
-		SMB_CO_UNLOCK(cp);
+		SMB_CO_UNLOCK(&ilock);
 		return;
 	}
 	cp->co_usecount--;
 	cp->co_flags |= SMBO_GONE;
 
-	lockmgr(&cp->co_lock, LK_DRAIN | LK_INTERLOCK, &cp->co_interlock, td);
+	lockmgr(&cp->co_lock, LK_DRAIN | LK_INTERLOCK, &ilock, td);
 	smb_co_gone(cp, scred);
 }
 
 int
-smb_co_get(struct smb_connobj *cp, int flags, struct smb_cred *scred)
+smb_co_get(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct smb_cred *scred)
 {
 	int error;
+	smb_ilock iilock;
 
-	if ((flags & LK_INTERLOCK) == 0)
-		SMB_CO_LOCK(cp);
+	if ((flags & LK_INTERLOCK) == 0) {
+		SMB_CO_LOCK(&iilock, cp);
+		ilock = &iilock;
+	}
 	cp->co_usecount++;
-	error = smb_co_lock(cp, flags | LK_INTERLOCK, scred->scr_td);
+	error = smb_co_lock(cp, ilock, flags | LK_INTERLOCK, scred->scr_td);
 	if (error) {
-		SMB_CO_LOCK(cp);
+		SMB_CO_LOCK(ilock, cp);
 		cp->co_usecount--;
-		SMB_CO_UNLOCK(cp);
+		SMB_CO_UNLOCK(ilock);
 		return error;
 	}
 	return 0;
@@ -309,9 +314,10 @@
 {
 	struct thread *td = scred->scr_td;
 	int flags;
+	smb_ilock ilock;
 
 	flags = LK_RELEASE;
-	SMB_CO_LOCK(cp);
+	SMB_CO_LOCK(&ilock, cp);
 	if (cp->co_usecount > 1) {
 		cp->co_usecount--;
 	} else if (cp->co_usecount == 1) {
@@ -321,7 +327,7 @@
 	} else {
 		SMBERROR("negative usecount");
 	}
-	lockmgr(&cp->co_lock, LK_RELEASE | LK_INTERLOCK, &cp->co_interlock, td);
+	lockmgr(&cp->co_lock, LK_RELEASE | LK_INTERLOCK, &ilock, td);
 	if ((cp->co_flags & SMBO_GONE) == 0)
 		return;
 	lockmgr(&cp->co_lock, LK_DRAIN, NULL, td);
@@ -335,9 +341,8 @@
 }
 
 int
-smb_co_lock(struct smb_connobj *cp, int flags, struct thread *td)
+smb_co_lock(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct thread *td)
 {
-
 	if (cp->co_flags & SMBO_GONE)
 		return EINVAL;
 	if ((flags & LK_TYPE_MASK) == 0)
@@ -347,13 +352,13 @@
 		SMBERROR("recursive lock for object %d\n", cp->co_level);
 		return 0;
 	}
-	return lockmgr(&cp->co_lock, flags, &cp->co_interlock, td);
+	return lockmgr(&cp->co_lock, flags, ilock, td);
 }
 
 void
-smb_co_unlock(struct smb_connobj *cp, int flags, struct thread *td)
+smb_co_unlock(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct thread *td)
 {
-	(void)lockmgr(&cp->co_lock, flags | LK_RELEASE, &cp->co_interlock, td);
+	lockmgr(&cp->co_lock, flags | LK_RELEASE, ilock, td);
 }
 
 static void
@@ -502,7 +507,7 @@
 int
 smb_vc_get(struct smb_vc *vcp, int flags, struct smb_cred *scred)
 {
-	return smb_co_get(VCTOCP(vcp), flags, scred);
+	return smb_co_get(VCTOCP(vcp), NULL, flags, scred);
 }
 
 void
@@ -514,13 +519,13 @@
 int
 smb_vc_lock(struct smb_vc *vcp, int flags, struct thread *td)
 {
-	return smb_co_lock(VCTOCP(vcp), flags, td);
+	return smb_co_lock(VCTOCP(vcp), NULL, flags, td);
 }
 
 void
 smb_vc_unlock(struct smb_vc *vcp, int flags, struct thread *td)
 {
-	smb_co_unlock(VCTOCP(vcp), flags, td);
+	smb_co_unlock(VCTOCP(vcp), NULL, flags, td);
 }
 
 int
@@ -646,10 +651,11 @@
 smb_vc_nextmid(struct smb_vc *vcp)
 {
 	u_short r;
+	smb_ilock ilock;
 
-	SMB_CO_LOCK(&vcp->obj);
+	SMB_CO_LOCK(&ilock, &vcp->obj);
 	r = vcp->vc_mid++;
-	SMB_CO_UNLOCK(&vcp->obj);
+	SMB_CO_UNLOCK(&ilock);
 	return r;
 }
 
@@ -743,7 +749,7 @@
 int
 smb_share_get(struct smb_share *ssp, int flags, struct smb_cred *scred)
 {
-	return smb_co_get(SSTOCP(ssp), flags, scred);
+	return smb_co_get(SSTOCP(ssp), NULL, flags, scred);
 }
 
 void
@@ -755,13 +761,13 @@
 int
 smb_share_lock(struct smb_share *ssp, int flags, struct thread *td)
 {
-	return smb_co_lock(SSTOCP(ssp), flags, td);
+	return smb_co_lock(SSTOCP(ssp), NULL, flags, td);
 }
 
 void
 smb_share_unlock(struct smb_share *ssp, int flags, struct thread *td)
 {
-	smb_co_unlock(SSTOCP(ssp), flags, td);
+	smb_co_unlock(SSTOCP(ssp), NULL, flags, td);
 }
 
 int
Index: netproto/smb/smb_conn.h
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_conn.h,v
retrieving revision 1.4
diff -u -r1.4 smb_conn.h
--- netproto/smb/smb_conn.h	7 Aug 2003 21:17:38 -0000	1.4
+++ netproto/smb/smb_conn.h	22 Feb 2004 07:35:29 -0000
@@ -199,8 +199,8 @@
 typedef void smb_co_gone_t (struct smb_connobj *cp, struct smb_cred *scred);
 typedef void smb_co_free_t (struct smb_connobj *cp);
 
-#define	SMB_CO_LOCK(cp)		smb_sl_lock(&(cp)->co_interlock)
-#define	SMB_CO_UNLOCK(cp)	smb_sl_unlock(&(cp)->co_interlock)
+#define	SMB_CO_LOCK(ilock, cp)	smb_sl_lock(ilock, &(cp)->co_interlock)
+#define	SMB_CO_UNLOCK(ilock)	smb_sl_unlock(ilock)
 
 struct smb_connobj {
 	int			co_level;	/* SMBL_ */
@@ -231,8 +231,8 @@
 /*
  * This lock protects vc_flags
  */
-#define	SMBC_ST_LOCK(vcp)	smb_sl_lock(&(vcp)->vc_stlock)
-#define	SMBC_ST_UNLOCK(vcp)	smb_sl_unlock(&(vcp)->vc_stlock)
+#define	SMBC_ST_LOCK(ilock, vcp)	smb_sl_lock(ilock, &(vcp)->vc_stlock)
+#define	SMBC_ST_UNLOCK(ilock)		smb_sl_unlock(ilock)
 
 
 struct smb_vc {
@@ -284,9 +284,9 @@
 /*
  * This lock protects ss_flags
  */
-#define	SMBS_ST_LOCK(ssp)	smb_sl_lock(&(ssp)->ss_stlock)
-#define	SMBS_ST_LOCKPTR(ssp)	(&(ssp)->ss_stlock)
-#define	SMBS_ST_UNLOCK(ssp)	smb_sl_unlock(&(ssp)->ss_stlock)
+#define	SMBS_ST_LOCK(ilock, ssp)	smb_sl_lock(ilock, &(ssp)->ss_stlock)
+#define	SMBS_ST_LOCKPTR(ssp)		(&(ssp)->ss_stlock)
+#define	SMBS_ST_UNLOCK(ilock)		smb_sl_unlock(ilock)
 
 struct smb_share {
 	struct smb_connobj obj;
@@ -359,10 +359,10 @@
  */
 void smb_co_ref(struct smb_connobj *cp, struct thread *td);
 void smb_co_rele(struct smb_connobj *cp, struct smb_cred *scred);
-int  smb_co_get(struct smb_connobj *cp, int flags, struct smb_cred *scred);
+int  smb_co_get(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct smb_cred *scred);
 void smb_co_put(struct smb_connobj *cp, struct smb_cred *scred);
-int  smb_co_lock(struct smb_connobj *cp, int flags, struct thread *td);
-void smb_co_unlock(struct smb_connobj *cp, int flags, struct thread *td);
+int  smb_co_lock(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct thread *td);
+void smb_co_unlock(struct smb_connobj *cp, smb_ilock *ilock, int flags, struct thread *td);
 
 /*
  * session level functions
Index: netproto/smb/smb_iod.c
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_iod.c,v
retrieving revision 1.7
diff -u -r1.7 smb_iod.c
--- netproto/smb/smb_iod.c	7 Aug 2003 21:17:39 -0000	1.7
+++ netproto/smb/smb_iod.c	22 Feb 2004 07:07:31 -0000
@@ -53,12 +53,12 @@
 #define	SMBIOD_PING_TIMO	60	/* seconds */
 
 #define	SMB_IOD_EVLOCKPTR(iod)	(&((iod)->iod_evlock))
-#define	SMB_IOD_EVLOCK(iod)	smb_sl_lock(&((iod)->iod_evlock))
-#define	SMB_IOD_EVUNLOCK(iod)	smb_sl_unlock(&((iod)->iod_evlock))
+#define	SMB_IOD_EVLOCK(ilock, iod)	smb_sl_lock(ilock, &((iod)->iod_evlock))
+#define	SMB_IOD_EVUNLOCK(ilock)	smb_sl_unlock(ilock)
 
 #define	SMB_IOD_RQLOCKPTR(iod)	(&((iod)->iod_rqlock))
-#define	SMB_IOD_RQLOCK(iod)	smb_sl_lock(&((iod)->iod_rqlock))
-#define	SMB_IOD_RQUNLOCK(iod)	smb_sl_unlock(&((iod)->iod_rqlock))
+#define	SMB_IOD_RQLOCK(ilock, iod)	smb_sl_lock(ilock, &((iod)->iod_rqlock))
+#define	SMB_IOD_RQUNLOCK(ilock)	smb_sl_unlock(ilock)
 
 #define	smb_iod_wakeup(iod)	wakeup(&(iod)->iod_flags)
 
@@ -74,30 +74,36 @@
 static __inline void
 smb_iod_rqprocessed(struct smb_rq *rqp, int error)
 {
-	SMBRQ_SLOCK(rqp);
+	smb_ilock ilock;
+
+	SMBRQ_SLOCK(&ilock, rqp);
 	rqp->sr_lerror = error;
 	rqp->sr_rpgen++;
 	rqp->sr_state = SMBRQ_NOTIFIED;
 	wakeup(&rqp->sr_state);
-	SMBRQ_SUNLOCK(rqp);
+	SMBRQ_SUNLOCK(&ilock);
 }
 
 static void
 smb_iod_invrq(struct smbiod *iod)
 {
 	struct smb_rq *rqp;
+	smb_ilock ilock;
 
 	/*
 	 * Invalidate all outstanding requests for this connection
 	 */
-	SMB_IOD_RQLOCK(iod);
+	SMB_IOD_RQLOCK(&ilock, iod);
 	TAILQ_FOREACH(rqp, &iod->iod_rqlist, sr_link) {
+#if 0
+		/* this makes no sense whatsoever XXX */
 		if (rqp->sr_flags & SMBR_INTERNAL)
 			SMBRQ_SUNLOCK(rqp);
+#endif
 		rqp->sr_flags |= SMBR_RESTART;
 		smb_iod_rqprocessed(rqp, ENOTCONN);
 	}
-	SMB_IOD_RQUNLOCK(iod);
+	SMB_IOD_RQUNLOCK(&ilock);
 }
 
 static void
@@ -185,6 +191,7 @@
 smb_iod_treeconnect(struct smbiod *iod, struct smb_share *ssp)
 {
 	int error;
+	smb_ilock ilock;
 
 	if (iod->iod_state != SMBIOD_ST_VCACTIVE) {
 		if (iod->iod_state != SMBIOD_ST_DEAD)
@@ -195,13 +202,13 @@
 			return error;
 	}
 	SMBIODEBUG("tree reconnect\n");
-	SMBS_ST_LOCK(ssp);
+	SMBS_ST_LOCK(&ilock, ssp);
 	ssp->ss_flags |= SMBS_RECONNECTING;
-	SMBS_ST_UNLOCK(ssp);
+	SMBS_ST_UNLOCK(&ilock);
 	error = smb_smb_treeconnect(ssp, &iod->iod_scred);
-	SMBS_ST_LOCK(ssp);
+	SMBS_ST_LOCK(&ilock, ssp);
 	ssp->ss_flags &= ~SMBS_RECONNECTING;
-	SMBS_ST_UNLOCK(ssp);
+	SMBS_ST_UNLOCK(&ilock);
 	wakeup(&ssp->ss_vcgenid);
 	return error;
 }
@@ -284,6 +291,8 @@
 	u_char *hp;
 	u_short mid;
 	int error;
+	smb_ilock ilock;
+	smb_ilock jlock;
 
 	switch (iod->iod_state) {
 	    case SMBIOD_ST_NOTCONN:
@@ -324,27 +333,27 @@
 		}
 		mid = SMB_HDRMID(hp);
 		SMBSDEBUG("mid %04x\n", (u_int)mid);
-		SMB_IOD_RQLOCK(iod);
+		SMB_IOD_RQLOCK(&ilock, iod);
 		TAILQ_FOREACH(rqp, &iod->iod_rqlist, sr_link) {
 			if (rqp->sr_mid != mid)
 				continue;
-			SMBRQ_SLOCK(rqp);
+			SMBRQ_SLOCK(&jlock, rqp);
 			if (rqp->sr_rp.md_top == NULL) {
 				md_initm(&rqp->sr_rp, m);
 			} else {
 				if (rqp->sr_flags & SMBR_MULTIPACKET) {
 					md_append_record(&rqp->sr_rp, m);
 				} else {
-					SMBRQ_SUNLOCK(rqp);
+					SMBRQ_SUNLOCK(&jlock);
 					SMBERROR("duplicate response %d (ignored)\n", mid);
 					break;
 				}
 			}
-			SMBRQ_SUNLOCK(rqp);
+			SMBRQ_SUNLOCK(&jlock);
 			smb_iod_rqprocessed(rqp, 0);
 			break;
 		}
-		SMB_IOD_RQUNLOCK(iod);
+		SMB_IOD_RQUNLOCK(&ilock);
 		if (rqp == NULL) {
 			SMBERROR("drop resp with mid %d\n", (u_int)mid);
 /*			smb_printrqlist(vcp);*/
@@ -354,13 +363,13 @@
 	/*
 	 * check for interrupts
 	 */
-	SMB_IOD_RQLOCK(iod);
+	SMB_IOD_RQLOCK(&ilock, iod);
 	TAILQ_FOREACH(rqp, &iod->iod_rqlist, sr_link) {
 		if (smb_proc_intr(rqp->sr_cred->scr_td)) {
 			smb_iod_rqprocessed(rqp, EINTR);
 		}
 	}
-	SMB_IOD_RQUNLOCK(iod);
+	SMB_IOD_RQUNLOCK(&ilock);
 	return 0;
 }
 
@@ -369,20 +378,21 @@
 {
 	struct smbiod_event *evp;
 	int error;
+	smb_ilock ilock;
 
 	SMBIODEBUG("\n");
 	evp = smb_zmalloc(sizeof(*evp), M_SMBIOD, M_WAITOK);
 	evp->ev_type = event;
 	evp->ev_ident = ident;
-	SMB_IOD_EVLOCK(iod);
+	SMB_IOD_EVLOCK(&ilock, iod);
 	STAILQ_INSERT_TAIL(&iod->iod_evlist, evp, ev_link);
 	if ((event & SMBIOD_EV_SYNC) == 0) {
-		SMB_IOD_EVUNLOCK(iod);
+		SMB_IOD_EVUNLOCK(&ilock);
 		smb_iod_wakeup(iod);
 		return 0;
 	}
 	smb_iod_wakeup(iod);
-	smb_sleep(evp, SMB_IOD_EVLOCKPTR(iod), PDROP, "90evw", 0);
+	smb_sleep(evp, &ilock, PDROP, "90evw", 0);
 	error = evp->ev_error;
 	free(evp, M_SMBIOD);
 	return error;
@@ -397,14 +407,15 @@
 {
 	struct smb_vc *vcp = rqp->sr_vc;
 	struct smbiod *iod = vcp->vc_iod;
+	smb_ilock ilock;
 	int error;
 
 	SMBIODEBUG("\n");
 	if (rqp->sr_cred->scr_td == iod->iod_td) {
 		rqp->sr_flags |= SMBR_INTERNAL;
-		SMB_IOD_RQLOCK(iod);
+		SMB_IOD_RQLOCK(&ilock, iod);
 		TAILQ_INSERT_HEAD(&iod->iod_rqlist, rqp, sr_link);
-		SMB_IOD_RQUNLOCK(iod);
+		SMB_IOD_RQUNLOCK(&ilock);
 		for (;;) {
 			if (smb_iod_sendrq(iod, rqp) != 0) {
 				smb_iod_dead(iod);
@@ -434,7 +445,7 @@
 		break;
 	}
 
-	SMB_IOD_RQLOCK(iod);
+	SMB_IOD_RQLOCK(&ilock, iod);
 	for (;;) {
 		if (vcp->vc_maxmux == 0) {
 			SMBERROR("maxmux == 0\n");
@@ -443,12 +454,11 @@
 		if (iod->iod_muxcnt < vcp->vc_maxmux)
 			break;
 		iod->iod_muxwant++;
-		smb_sleep(&iod->iod_muxwant, SMB_IOD_RQLOCKPTR(iod),
-		    0, "90mux", 0);
+		smb_sleep(&iod->iod_muxwant, &ilock, 0, "90mux", 0);
 	}
 	iod->iod_muxcnt++;
 	TAILQ_INSERT_TAIL(&iod->iod_rqlist, rqp, sr_link);
-	SMB_IOD_RQUNLOCK(iod);
+	SMB_IOD_RQUNLOCK(&ilock);
 	smb_iod_wakeup(iod);
 	return 0;
 }
@@ -458,18 +468,19 @@
 {
 	struct smb_vc *vcp = rqp->sr_vc;
 	struct smbiod *iod = vcp->vc_iod;
+	smb_ilock ilock;
 
 	SMBIODEBUG("\n");
 	if (rqp->sr_flags & SMBR_INTERNAL) {
-		SMB_IOD_RQLOCK(iod);
+		SMB_IOD_RQLOCK(&ilock, iod);
 		TAILQ_REMOVE(&iod->iod_rqlist, rqp, sr_link);
-		SMB_IOD_RQUNLOCK(iod);
+		SMB_IOD_RQUNLOCK(&ilock);
 		return 0;
 	}
-	SMB_IOD_RQLOCK(iod);
+	SMB_IOD_RQLOCK(&ilock, iod);
 	while (rqp->sr_flags & SMBR_XLOCK) {
 		rqp->sr_flags |= SMBR_XLOCKWANT;
-		smb_sleep(rqp, SMB_IOD_RQLOCKPTR(iod), 0, "90xrm", 0);
+		smb_sleep(rqp, &ilock, 0, "90xrm", 0);
 	}
 	TAILQ_REMOVE(&iod->iod_rqlist, rqp, sr_link);
 	iod->iod_muxcnt--;
@@ -477,7 +488,7 @@
 		iod->iod_muxwant--;
 		wakeup(&iod->iod_muxwant);
 	}
-	SMB_IOD_RQUNLOCK(iod);
+	SMB_IOD_RQUNLOCK(&ilock);
 	return 0;
 }
 
@@ -485,6 +496,7 @@
 smb_iod_waitrq(struct smb_rq *rqp)
 {
 	struct smbiod *iod = rqp->sr_vc->vc_iod;
+	smb_ilock ilock;
 	int error;
 
 	SMBIODEBUG("\n");
@@ -500,21 +512,21 @@
 		return rqp->sr_lerror;
 
 	}
-	SMBRQ_SLOCK(rqp);
+	SMBRQ_SLOCK(&ilock, rqp);
 	if (rqp->sr_rpgen == rqp->sr_rplast)
-		smb_sleep(&rqp->sr_state, SMBRQ_SLOCKPTR(rqp), 0, "90wrq", 0);
+		smb_sleep(&rqp->sr_state, &ilock, 0, "90wrq", 0);
 	rqp->sr_rplast++;
-	SMBRQ_SUNLOCK(rqp);
+	SMBRQ_SUNLOCK(&ilock);
 	error = rqp->sr_lerror;
 	if (rqp->sr_flags & SMBR_MULTIPACKET) {
 		/*
 		 * If request should stay in the list, then reinsert it
 		 * at the end of queue so other waiters have chance to concur
 		 */
-		SMB_IOD_RQLOCK(iod);
+		SMB_IOD_RQLOCK(&ilock, iod);
 		TAILQ_REMOVE(&iod->iod_rqlist, rqp, sr_link);
 		TAILQ_INSERT_TAIL(&iod->iod_rqlist, rqp, sr_link);
-		SMB_IOD_RQUNLOCK(iod);
+		SMB_IOD_RQUNLOCK(&ilock);
 	} else
 		smb_iod_removerq(rqp);
 	return error;
@@ -527,20 +539,21 @@
 	struct smb_vc *vcp = iod->iod_vc;
 	struct smb_rq *rqp;
 	struct timespec ts, tstimeout;
+	smb_ilock ilock;
 	int herror;
 
 	herror = 0;
 	/*
 	 * Loop through the list of requests and send them if possible
 	 */
-	SMB_IOD_RQLOCK(iod);
+	SMB_IOD_RQLOCK(&ilock, iod);
 	TAILQ_FOREACH(rqp, &iod->iod_rqlist, sr_link) {
 		switch (rqp->sr_state) {
 		    case SMBRQ_NOTSENT:
 			rqp->sr_flags |= SMBR_XLOCK;
-			SMB_IOD_RQUNLOCK(iod);
+			SMB_IOD_RQUNLOCK(&ilock);
 			herror = smb_iod_sendrq(iod, rqp);
-			SMB_IOD_RQLOCK(iod);
+			SMB_IOD_RQLOCK(&ilock, iod);
 			rqp->sr_flags &= ~SMBR_XLOCK;
 			if (rqp->sr_flags & SMBR_XLOCKWANT) {
 				rqp->sr_flags &= ~SMBR_XLOCKWANT;
@@ -561,7 +574,7 @@
 		if (herror)
 			break;
 	}
-	SMB_IOD_RQUNLOCK(iod);
+	SMB_IOD_RQUNLOCK(&ilock);
 	if (herror == ENOTCONN)
 		smb_iod_dead(iod);
 	return 0;
@@ -577,6 +590,7 @@
 	struct smbiod_event *evp;
 /*	struct timespec tsnow;*/
 	int error;
+	smb_ilock ilock;
 
 	SMBIODEBUG("\n");
 	error = 0;
@@ -585,15 +599,15 @@
 	 * Check all interesting events
 	 */
 	for (;;) {
-		SMB_IOD_EVLOCK(iod);
+		SMB_IOD_EVLOCK(&ilock, iod);
 		evp = STAILQ_FIRST(&iod->iod_evlist);
 		if (evp == NULL) {
-			SMB_IOD_EVUNLOCK(iod);
+			SMB_IOD_EVUNLOCK(&ilock);
 			break;
 		}
 		STAILQ_REMOVE_HEAD(&iod->iod_evlist, ev_link);
 		evp->ev_type |= SMBIOD_EV_PROCESSING;
-		SMB_IOD_EVUNLOCK(iod);
+		SMB_IOD_EVUNLOCK(&ilock);
 		switch (evp->ev_type & SMBIOD_EV_MASK) {
 		    case SMBIOD_EV_CONNECT:
 			iod->iod_state = SMBIOD_ST_RECONNECT;
@@ -612,9 +626,9 @@
 			break;
 		}
 		if (evp->ev_type & SMBIOD_EV_SYNC) {
-			SMB_IOD_EVLOCK(iod);
+			SMB_IOD_EVLOCK(&ilock, iod);
 			wakeup(evp);
-			SMB_IOD_EVUNLOCK(iod);
+			SMB_IOD_EVUNLOCK(&ilock);
 		} else
 			free(evp, M_SMBIOD);
 	}
Index: netproto/smb/smb_rq.c
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_rq.c,v
retrieving revision 1.6
diff -u -r1.6 smb_rq.c
--- netproto/smb/smb_rq.c	7 Aug 2003 21:17:39 -0000	1.6
+++ netproto/smb/smb_rq.c	22 Feb 2004 07:05:08 -0000
@@ -172,23 +172,24 @@
 {
 	struct smb_share *ssp = rqp->sr_share;
 	int error;
+	smb_ilock ilock;
 
 	if (ssp == NULL || rqp->sr_cred == &rqp->sr_vc->vc_iod->iod_scred) {
 		return smb_iod_addrq(rqp);
 	}
 	for (;;) {
-		SMBS_ST_LOCK(ssp);
+		SMBS_ST_LOCK(&ilock, ssp);
 		if (ssp->ss_flags & SMBS_RECONNECTING) {
-			smb_sleep(&ssp->ss_vcgenid, SMBS_ST_LOCKPTR(ssp),
-			    PDROP, "90trcn", hz);
+			smb_sleep(&ssp->ss_vcgenid, &ilock, 
+				PDROP, "90trcn", hz);
 			if (smb_proc_intr(rqp->sr_cred->scr_td))
 				return EINTR;
 			continue;
 		}
 		if (smb_share_valid(ssp) || (ssp->ss_flags & SMBS_CONNECTED) == 0) {
-			SMBS_ST_UNLOCK(ssp);
+			SMBS_ST_UNLOCK(&ilock);
 		} else {
-			SMBS_ST_UNLOCK(ssp);
+			SMBS_ST_UNLOCK(&ilock);
 			error = smb_iod_request(rqp->sr_vc->vc_iod,
 			    SMBIOD_EV_TREECONNECT | SMBIOD_EV_SYNC, ssp);
 			if (error)
@@ -438,6 +439,7 @@
 	u_int16_t totpcount, totdcount, pcount, poff, doff, pdisp, ddisp;
 	u_int16_t tmp, bc, dcount;
 	u_int8_t wc;
+	smb_ilock ilock;
 
 	error = smb_rq_reply(rqp);
 	if (error)
@@ -446,9 +448,9 @@
 		/* 
 		 * this is an interim response, ignore it.
 		 */
-		SMBRQ_SLOCK(rqp);
+		SMBRQ_SLOCK(&ilock, rqp);
 		md_next_record(&rqp->sr_rp);
-		SMBRQ_SUNLOCK(rqp);
+		SMBRQ_SUNLOCK(&ilock);
 		return 0;
 	}
 	/*
@@ -524,9 +526,9 @@
 		/*
 		 * We're done with this reply, look for the next one.
 		 */
-		SMBRQ_SLOCK(rqp);
+		SMBRQ_SLOCK(&ilock, rqp);
 		md_next_record(&rqp->sr_rp);
-		SMBRQ_SUNLOCK(rqp);
+		SMBRQ_SUNLOCK(&ilock);
 		error = smb_rq_reply(rqp);
 		if (error)
 			break;
Index: netproto/smb/smb_rq.h
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_rq.h,v
retrieving revision 1.2
diff -u -r1.2 smb_rq.h
--- netproto/smb/smb_rq.h	17 Jun 2003 04:28:54 -0000	1.2
+++ netproto/smb/smb_rq.h	22 Feb 2004 07:01:30 -0000
@@ -56,8 +56,8 @@
 #define	SMBT2_RESTART		0x0008
 #define	SMBT2_NORESTART		0x0010
 
-#define SMBRQ_SLOCK(rqp)	smb_sl_lock(&(rqp)->sr_slock)
-#define SMBRQ_SUNLOCK(rqp)	smb_sl_unlock(&(rqp)->sr_slock)
+#define SMBRQ_SLOCK(ilock, rqp)	smb_sl_lock(ilock, &(rqp)->sr_slock)
+#define SMBRQ_SUNLOCK(ilock)	smb_sl_unlock(ilock)
 #define SMBRQ_SLOCKPTR(rqp)	(&(rqp)->sr_slock)
 
 
Index: netproto/smb/smb_subr.c
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_subr.c,v
retrieving revision 1.9
diff -u -r1.9 smb_subr.c
--- netproto/smb/smb_subr.c	9 Nov 2003 02:22:37 -0000	1.9
+++ netproto/smb/smb_subr.c	22 Feb 2004 06:57:57 -0000
@@ -429,15 +429,13 @@
  * since we blocked, so reget or release as appropriate.
  */
 int
-smb_sleep(void *chan, struct lwkt_token *mtx, int slpflags, const char *wmesg, int timo)
+smb_sleep(void *chan, struct lwkt_tokref *ilock, int slpflags, const char *wmesg, int timo)
 {
 	int error;
 
 	error = tsleep(chan, slpflags, wmesg, timo);
-	if ((slpflags & PDROP) == 0 && mtx)
-		lwkt_regettoken(mtx);
-	else
-		lwkt_reltoken(mtx);
+	if ((slpflags & PDROP) && ilock)
+		lwkt_reltoken(ilock);
 	return error;
 }
 
Index: netproto/smb/smb_subr.h
===================================================================
RCS file: /cvs/src/sys/netproto/smb/smb_subr.h,v
retrieving revision 1.7
diff -u -r1.7 smb_subr.h
--- netproto/smb/smb_subr.h	15 Nov 2003 21:05:43 -0000	1.7
+++ netproto/smb/smb_subr.h	22 Feb 2004 05:05:13 -0000
@@ -80,10 +80,11 @@
 
 #define	lockdestroy(lock)
 #define	smb_slock			lwkt_token
-#define	smb_sl_init(mtx, desc)		lwkt_inittoken(mtx)
-#define	smb_sl_destroy(mtx)
-#define	smb_sl_lock(mtx)		lwkt_gettoken(mtx)
-#define	smb_sl_unlock(mtx)		lwkt_reltoken(mtx)
+#define	smb_ilock			lwkt_tokref
+#define	smb_sl_init(tok, desc)		lwkt_token_init(tok)
+#define	smb_sl_destroy(tok)
+#define	smb_sl_lock(ilock, tok)		lwkt_gettoken(ilock, tok)
+#define	smb_sl_unlock(ilock)		lwkt_reltoken(ilock)
 
 #define SMB_STRFREE(p)	do { if (p) smb_strfree(p); } while(0)
 
@@ -139,7 +140,8 @@
 struct mbchain;
 struct proc;
 struct thread;
-struct lwkt_token;
+struct lwkt_tokref;
+struct lwkt_rwlock;
 struct smb_vc;
 struct smb_rq;
 
@@ -171,7 +173,7 @@
  */
 int kthread_create2(void (*func)(void *), void *arg,
     struct proc **newpp, int flags, const char *fmt, ...);
-int smb_sleep(void *chan, struct lwkt_token *mtx, int slpflags, const char *wmesg, int timo);
+int smb_sleep(void *chan, struct lwkt_tokref *ilock, int slpflags, const char *wmesg, int timo);
 
 
 #endif /* !_NETSMB_SMB_SUBR_H_ */
Index: sys/buf2.h
===================================================================
RCS file: /cvs/src/sys/sys/buf2.h,v
retrieving revision 1.6
diff -u -r1.6 buf2.h
--- sys/buf2.h	20 Aug 2003 07:31:21 -0000	1.6
+++ sys/buf2.h	24 Feb 2004 18:36:33 -0000
@@ -63,15 +63,16 @@
 static __inline int
 BUF_LOCK(struct buf *bp, int locktype)
 {
+	lwkt_tokref ilock;
 	int s, ret;
 
 	s = splbio();
-	lwkt_gettoken(&buftimetoken);
+	lwkt_gettoken(&ilock, &buftimetoken);
 	locktype |= LK_INTERLOCK;
 	bp->b_lock.lk_wmesg = buf_wmesg;
 	bp->b_lock.lk_prio = 0;		/* tsleep flags */
 	/* bp->b_lock.lk_timo = 0;   not necessary */
-	ret = lockmgr(&(bp)->b_lock, locktype, &buftimetoken, curthread);
+	ret = lockmgr(&(bp)->b_lock, locktype, &ilock, curthread);
 	splx(s);
 	return ret;
 }
@@ -82,15 +83,16 @@
 static __inline int
 BUF_TIMELOCK(struct buf *bp, int locktype, char *wmesg, int catch, int timo)
 {
+	lwkt_tokref ilock;
 	int s, ret;
 
 	s = splbio();
-	lwkt_gettoken(&buftimetoken);
+	lwkt_gettoken(&ilock, &buftimetoken);
 	locktype |= LK_INTERLOCK | LK_TIMELOCK;
 	bp->b_lock.lk_wmesg = wmesg;
 	bp->b_lock.lk_prio = catch;	/* tsleep flags */
 	bp->b_lock.lk_timo = timo;
-	ret = lockmgr(&(bp)->b_lock, (locktype), &buftimetoken, curthread);
+	ret = lockmgr(&(bp)->b_lock, locktype, &ilock, curthread);
 	splx(s);
 	return ret;
 }
Index: sys/globaldata.h
===================================================================
RCS file: /cvs/src/sys/sys/globaldata.h,v
retrieving revision 1.26
diff -u -r1.26 globaldata.h
--- sys/globaldata.h	20 Feb 2004 17:11:08 -0000	1.26
+++ sys/globaldata.h	21 Feb 2004 22:06:58 -0000
@@ -119,6 +119,7 @@
 
 	struct pipe	*gd_pipeq;		/* cache pipe structures */
 	int		gd_pipeqcount;		/* number of structures */
+	lwkt_tokref_t 	gd_tokreqbase;		/* requests from other cpus */
 	/* extended by <machine/pcpu.h> */
 };
 
Index: sys/kernel.h
===================================================================
RCS file: /cvs/src/sys/sys/kernel.h,v
retrieving revision 1.9
diff -u -r1.9 kernel.h
--- sys/kernel.h	25 Feb 2004 17:38:51 -0000	1.9
+++ sys/kernel.h	25 Feb 2004 18:12:25 -0000
@@ -128,6 +128,7 @@
 	SI_SUB_CONFIGURE	= 0x3800000,	/* Configure devices */
 	SI_SUB_VFS		= 0x4000000,	/* virtual file system*/
 	SI_SUB_CLOCKS		= 0x4800000,	/* real time and stat clocks*/
+	SI_SUB_FINISH_SMP	= 0x5000000,	/* finish setting up cpus */
 	SI_SUB_CLIST		= 0x5800000,	/* clists*/
 	SI_SUB_SYSV_SHM		= 0x6400000,	/* System V shared memory*/
 	SI_SUB_SYSV_SEM		= 0x6800000,	/* System V semaphores*/
Index: sys/lock.h
===================================================================
RCS file: /cvs/src/sys/sys/lock.h,v
retrieving revision 1.7
diff -u -r1.7 lock.h
--- sys/lock.h	21 Nov 2003 22:46:13 -0000	1.7
+++ sys/lock.h	22 Feb 2004 05:21:17 -0000
@@ -193,7 +193,7 @@
 			int flags);
 #ifdef DEBUG_LOCKS
 int	debuglockmgr (struct lock *, u_int flags,
-			struct lwkt_token *, struct thread *p,
+			struct lwkt_tokref *, struct thread *p,
 			const char *,
 			const char *,
 			int);
@@ -202,7 +202,7 @@
 	    "lockmgr", __FILE__, __LINE__)
 #else
 int	lockmgr (struct lock *, u_int flags,
-			struct lwkt_token *, struct thread *td);
+			struct lwkt_tokref *, struct thread *td);
 #endif
 void	lockmgr_printinfo (struct lock *);
 int	lockstatus (struct lock *, struct thread *);
Index: sys/mount.h
===================================================================
RCS file: /cvs/src/sys/sys/mount.h,v
retrieving revision 1.8
diff -u -r1.8 mount.h
--- sys/mount.h	2 Feb 2004 05:43:15 -0000	1.8
+++ sys/mount.h	22 Feb 2004 19:54:00 -0000
@@ -111,6 +111,9 @@
  * will become the dirty list and mnt_reservedvnlist will become the 'clean'
  * list.  Filesystem kld's syncing code should remain compatible since
  * they only need to scan the dirty vnode list (nvnodelist -> dirtyvnodelist).
+ *
+ * NOTE: Any vnode marked VPLACEMARKER is a placemarker and should ALWAYS BE
+ * SKIPPED.  NO OTHER FIELDS IN SUCH VNODES ARE VALID.
  */
 TAILQ_HEAD(vnodelst, vnode);
 
@@ -435,7 +438,7 @@
 int	vfs_lock (struct mount *);         /* lock a vfs */
 void	vfs_msync (struct mount *, int);
 void	vfs_unlock (struct mount *);       /* unlock a vfs */
-int	vfs_busy (struct mount *, int, struct lwkt_token *, struct thread *);
+int	vfs_busy (struct mount *, int, struct lwkt_tokref *, struct thread *);
 int	vfs_export			    /* process mount export info */
 	  (struct mount *, struct netexport *, struct export_args *);
 struct	netcred *vfs_export_lookup	    /* lookup host in fs export list */
Index: sys/proc.h
===================================================================
RCS file: /cvs/src/sys/sys/proc.h,v
retrieving revision 1.42
diff -u -r1.42 proc.h
--- sys/proc.h	30 Jan 2004 05:42:18 -0000	1.42
+++ sys/proc.h	23 Feb 2004 01:11:53 -0000
@@ -449,7 +449,6 @@
 int	cpu_coredump (struct thread *, struct vnode *, struct ucred *);
 void	setsugid (void);
 void	faultin (struct proc *p);
-void	sched_thread_init(void);
 
 u_int32_t	procrunnable (void);
 
Index: sys/rman.h
===================================================================
RCS file: /cvs/src/sys/sys/rman.h,v
retrieving revision 1.6
diff -u -r1.6 rman.h
--- sys/rman.h	21 Feb 2004 09:17:10 -0000	1.6
+++ sys/rman.h	22 Feb 2004 07:12:15 -0000
@@ -77,6 +77,9 @@
 
 enum	rman_type { RMAN_UNINIT = 0, RMAN_GAUGE, RMAN_ARRAY };
 
+struct lwkt_token;
+struct lwkt_tokref;
+
 struct	rman {
 	struct	resource_head 	rm_list;
 	struct	lwkt_token 	*rm_slock; /* mutex used to protect rm_list */
@@ -91,7 +94,7 @@
 #ifdef _KERNEL
 
 int	rman_activate_resource(struct resource *r);
-int	rman_await_resource(struct resource *r, int slpflags, int timo);
+int	rman_await_resource(struct resource *r, struct lwkt_tokref *ilock, int slpflags, int timo);
 int	rman_deactivate_resource(struct resource *r);
 int	rman_fini(struct rman *rm);
 int	rman_init(struct rman *rm);
